From 452a58e4aabfad1bf2fe37c01b7b5324aa193b9d Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 30 2016 17:45:03 +0000
Subject: [PATCH 372/1001] Add a handy cache-coverage sanity check script.


---

diff --git a/cache-coverage.py b/cache-coverage.py
new file mode 100755
index 0000000..8aad708
--- /dev/null
+++ b/cache-coverage.py
@@ -0,0 +1,43 @@
+#!/usr/bin/env python
+""" cache coverage checker.
+
+Runs through all possible cache keys and checks if there is a corresponding
+value already cached for it.
+
+Useful as a sanity check during development.
+
+Could make a good nagios check one day.  If the cache coverage is below 50%,
+then the site will be very slow.  We should run some sort of script that
+forcibly re-warms the cache.
+
+Authors:    Ralph Bean <rbean@redhat.com>
+"""
+
+import sys
+import dogpile.cache
+
+import hubs.widgets.base
+import hubs.models
+
+import fedmsg.config
+
+config = fedmsg.config.load_config()
+
+empty, full = 0, 0
+session = hubs.models.init(config['hubs.sqlalchemy.uri'])
+for widget in session.query(hubs.models.Widget).all():
+    key = hubs.widgets.base.cache_key_generator(widget, **widget.config)
+    result = hubs.widgets.base.cache.get(key, ignore_expiration=True)
+    if isinstance(result, dogpile.cache.api.NoValue):
+        empty += 1
+    else:
+        full += 1
+    sys.stdout.write('.')
+    sys.stdout.flush()
+sys.stdout.write('\n')
+sys.stdout.flush()
+
+total = empty + full
+print full, "cache values found. ", empty, "are missing."
+print full / float(total) * 100, "percent cache coverage."
+

